# Active Check NTP

This plugin is an active check to monitor NTP servers.

<details><summary>check_ntp</summary>

This check plugin is a basic active check to monitor NTP servers.


In the service summary the plugin will show

-    Stratum
-    Reference ID
-    Server time


and in the deails
-    NTP mode
-    NTP version
-    Poll
-    Precision
-    Leap
-    Timestamps (Reference, Origin, Receive, Transmit, Destination)
-    Times (Reference, Origin, Receive, Transmit, Destination)

</details>

---
### Download
* [check_ntp.mkp (latest version)](https://thl-cmk.hopto.org/gitlab/checkmk/vendor-independent/check_ntp/-/raw/master/check_ntp.mkp "The check plugin") The check plugin
* [ntplib-0.4.0.mkp](https://thl-cmk.hopto.org/gitlab/checkmk/vendor-independent/check_ntp/-/raw/master/ntplib-0.4.0.mkp "python ntplib version 0.4.0") The python ntplib version 0.4.0                      

---
### Installation

You can install the package by uploading it to your CheckMK site and as site user run `mkp install check_ntp.mkp`.


In the Enterprise/Free edition of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

**Note**: before you can use this plugin you need to install the python **_ntplib_** into your CMK site. This can be done by issuing the command `pip3 install ntplib` as site user, as long as your CMK server has internet access. If you prefer not to download the ntplib from the internet you can also use the additional MKP package **_ntplib-0.4.0.mkp_** (see above).

---
### Want to Contribute?
Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info

The plugin creates the service **_NTP server_** with the an optional alternate service description as item.

<details><summary>Montoring states</summary>

| State | condition | WATO | 
| ------ | ------ | ------ |
| WARN | NTP server is not syncjronized (Stratum == 0) | yes |
| WARN/CRIT | Stratum at upper levels | yes |
| WARN/CRIT | offset at upper/lower levels | yes |
| WARN/CRIT | delay at upper levels | yes |
| WARN/CRIT | root dispersion at upper levels | yes |
| UNKNOWN | _ntplib_ not found | no |

</details>

<details><summary>Perfdata</summary>

| Metric | Unit | Perfometer |
| ------ | ------ | ------ |
| Offset | s | yes |
| Delay | s | no |
| Root dispersion | s | no |

</details>

---
### WATO
<details><summary>Active check rule</summary>

| Section | Rule name |
| ------ | ------ |
| HTTP, TCP, Email, ... | Check NTP service  |

| Option | Defailt value |
| ------ | ------ |
| Service description | none |
| Server IP-address or name | IP-Address/Hostname of the monitored host |
| NTP port | 123 |
| NTP version | 4 |
| Request timeout | 2 seconds |
| Monitoring state if server is not synchronized | CRIT |
| Monitoring state if server doesn't respond (timeout) | CRIT |
| max. stratum | 10, 15 |
| max. offset in ms | 200, 500 |
| max. delay in ms | 200, 500 |
| max. root dispersion in s | 3, 5 |

</details> 

---
### Sample Output

Sample output

![sample output](/doc/sample.png?raw=true "sample output")

Sample output details

![sample output details](/doc/sample-details.png?raw=true "sample output details")
